'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _noop2 = require('lodash/noop');

var _noop3 = _interopRequireDefault(_noop2);

var _trim2 = require('lodash/trim');

var _trim3 = _interopRequireDefault(_trim2);

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

var _isFunction2 = require('lodash/isFunction');

var _isFunction3 = _interopRequireDefault(_isFunction2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var scale = (0, _styledComponents.keyframes)(['0%{transform:scale(0)}90%{transform:scale(1.2)}100%{transform:scale(1)}']);

var CopyNotice = _styledComponents2.default.div.withConfig({
  displayName: 'Code__CopyNotice'
})(['position:absolute;top:0;right:0;padding:10px 15px;', ' border-radius:', ';background-color:', ';opacity:0;font-size:', ';color:', ';', ';'], function (props) {
  return props.isHovered && 'transition: opacity 300ms ease;';
}, function (props) {
  return props.theme.borderRadius.soft;
}, function (props) {
  return props.theme.colors.purple800;
}, function (props) {
  return props.theme.fontSizes.small;
}, function (props) {
  return props.theme.colors.purple50;
}, function (props) {
  return props.isCopying && '\n    & > i {\n        transform-origin: center;\n        animation-name: ' + scale + ';\n        animation-duration: .4s;\n      }\n  ';
});

var CodeWrapper = _styledComponents2.default.div.withConfig({
  displayName: 'Code__CodeWrapper'
})(['position:relative;background-color:', ';box-sizing:border-box;border-radius:', ';cursor:pointer;&:hover ', '{opacity:0.9;}'], function (props) {
  return props.theme.colors.purple800;
}, function (props) {
  return props.theme.borderRadius.soft;
}, CopyNotice);

var ScrollWrap = _styledComponents2.default.div.withConfig({
  displayName: 'Code__ScrollWrap'
})(['overflow:auto;']);

var Content = _styledComponents2.default.div.withConfig({
  displayName: 'Code__Content'
})(['flex-grow:1;color:', ';padding:10px 15px;'], function (props) {
  return props.theme.colors.purple50;
});

var Pre = _styledComponents2.default.pre.withConfig({
  displayName: 'Code__Pre'
})(['margin:10px 0;font-family:', ';font-size:', ';'], function (props) {
  return props.theme.fontFamilies.monospace;
}, function (props) {
  return props.theme.fontSizes.small;
});

var PaddedLine = _styledComponents2.default.div.withConfig({
  displayName: 'Code__PaddedLine'
})(['&:not(:last-child){padding-bottom:8px;}& > *{display:inline;}']);

var trimString = function trimString(node) {
  return (0, _isString3.default)(node) ? (0, _trim3.default)(node) : node;
};

var formatSingleCommand = function formatSingleCommand(children) {
  return (0, _isFunction3.default)(children) ? children() : trimString(children);
};

function formatMultiString(string) {
  return (0, _trim3.default)(string).split('\n').map(function (line) {
    return _react2.default.createElement(
      PaddedLine,
      { key: line },
      line,
      '\n'
    );
  });
}

function formatMultiCommand(raw) {
  var children = raw;

  if ((0, _isFunction3.default)(children)) {
    children = children();
  }
  var count = _react2.default.Children.count(children);

  if (count === 1) {
    return (0, _isString3.default)(children) ? formatMultiString(children) : children;
  }

  return _react2.default.Children.map(children, function (child, i) {
    return _react2.default.createElement(
      PaddedLine,
      { key: i },
      child,
      '\n'
    );
  });
}

/**
 * Code allows for easy rendering of code snippets which can easliy be copied to
 * the clipboard by clicking the element or selecting a portion of the code
 */

var Code = function (_Component) {
  _inherits(Code, _Component);

  function Code() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Code);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Code.__proto__ || Object.getPrototypeOf(Code)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isCopying: false,
      isHovered: false
    }, _this.componentDidUpdate = function () {
      // reselect text after re-render
      if (_this.state.selectedRange) {
        var prevRange = _this.state.selectedRange;
        var sel = window.getSelection();
        sel.removeAllRanges();
        sel.addRange(prevRange);
        // clear it for the next interaction
        _this.setState({ selectedRange: null });
      }
    }, _this.handleCopyClick = function () {
      // Create a textarea element in which the text of the code will be copied.
      // Set the value of the textarea, select it to set it as the active element,
      // then copy the value of that element to the clipboard.
      // It's 2017 and this is still the best way to copy text on button click...
      if ((0, _isFunction3.default)(_this.props.onCopy)) {
        _this.props.onCopy();
      }
      var selection = document.getSelection();
      var selectionString = selection.toString();
      // if user has selected text, save that to state so it can be reselected
      if (selectionString !== '') {
        _this.setState({
          selectedRange: selection.getRangeAt(0)
        });
      }

      var code = selectionString === '' ? _this.preNode.textContent : selectionString;
      var txtArea = document.createElement('textarea');
      // Safari doesn't allow for assigning an object literal to `style`.
      txtArea.class = 'hidden-textarea';
      // Make sure the code ends in a newline to execute all the commands in multiline code.
      if (code.charAt(code.length - 1) === '\n') {
        txtArea.value = code;
      } else {
        txtArea.value = code + '\n';
      }
      document.body.appendChild(txtArea);

      txtArea.select();

      try {
        document.execCommand('copy');
      } catch (e) {
        throw e;
      }
      document.body.removeChild(txtArea);

      // show the Copied to clipboard notice temporarily
      _this.setState({ isCopying: true });
      setTimeout(function () {
        _this.setState({ isCopying: false });
      }, 3000);
    }, _this.onMouseEnter = function () {
      _this.setState({
        isHovered: true
      });
    }, _this.onMouseLeave = function () {
      _this.setState({
        isHovered: false,
        isCopying: false
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Code, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          multiCommand = _props.multiCommand;
      var _state = this.state,
          isCopying = _state.isCopying,
          isHovered = _state.isHovered;


      var copy = isCopying && isHovered ? _react2.default.createElement('i', { className: 'fa fa-check' }) : 'Copy to clipboard';

      return _react2.default.createElement(
        CodeWrapper,
        {
          onClick: this.handleCopyClick,
          onMouseEnter: this.onMouseEnter,
          onMouseLeave: this.onMouseLeave
        },
        _react2.default.createElement(
          ScrollWrap,
          null,
          _react2.default.createElement(
            Content,
            null,
            _react2.default.createElement(
              Pre,
              { innerRef: function innerRef(e) {
                  return _this2.preNode = e;
                } },
              multiCommand ? formatMultiCommand(children) : formatSingleCommand(children)
            )
          )
        ),
        _react2.default.createElement(
          CopyNotice,
          { isCopying: isCopying, isHovered: isHovered },
          copy
        )
      );
    }
  }]);

  return Code;
}(_react.Component);

Code.displayName = 'Code';


Code.propTypes = {
  // children can be anything that React can render
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]).isRequired,

  // multiCommand determines if the code lines shall be padded
  multiCommand: _propTypes2.default.bool,

  // onCopy will be called when the CodeWrapper is clicked
  onCopy: _propTypes2.default.func
};

Code.defaultProps = {
  multiCommand: false,
  onCopy: _noop3.default
};

exports.default = Code;