'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _without2 = require('lodash/without');

var _without3 = _interopRequireDefault(_without2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LegendContainer = _styledComponents2.default.div.withConfig({
  displayName: '_Legend__LegendContainer'
})(['opacity:', ';'], function (props) {
  return props.loading ? 0.35 : 1;
});

var LegendItems = _styledComponents2.default.div.withConfig({
  displayName: '_Legend__LegendItems'
})(['color:', ';box-sizing:border-box;display:flex;flex-wrap:wrap;position:relative;padding:10px 0;width:100%;'], function (props) {
  return props.theme.colors.black;
});

var LegendItem = _styledComponents2.default.div.withConfig({
  displayName: '_Legend__LegendItem'
})(['cursor:pointer;display:flex;font-size:', ';align-items:center;padding:2px 16px 2px 7px;margin-right:2px;margin-bottom:2px;border-radius:', ';&:hover{background-color:', ';}', ';'], function (props) {
  return props.theme.fontSizes.small;
}, function (props) {
  return props.theme.borderRadius.soft;
}, function (props) {
  return props.theme.colors.purple100;
}, function (props) {
  return props.selected && '\n    background-color: ' + props.theme.colors.purple100 + ';\n  ';
});

var LegendItemName = _styledComponents2.default.span.withConfig({
  displayName: '_Legend__LegendItemName'
})(['white-space:nowrap;text-overflow:ellipsis;overflow:hidden;max-width:36ch;']);

var LegendToggle = _styledComponents2.default.span.withConfig({
  displayName: '_Legend__LegendToggle'
})(['color:', ';cursor:pointer;display:block;padding:5px;font-size:', ';width:fit-content;'], function (props) {
  return props.theme.colors.purple400;
}, function (props) {
  return props.theme.fontSizes.normal;
});

var LegendCaret = _styledComponents2.default.span.withConfig({
  displayName: '_Legend__LegendCaret'
})(['margin-left:5px;']);

var ColorBox = _styledComponents2.default.span.withConfig({
  displayName: '_Legend__ColorBox'
})(['background-color:', ';margin-right:4px;min-width:13px;height:5px;'], function (props) {
  return props.color;
});

var Legend = function (_React$PureComponent) {
  _inherits(Legend, _React$PureComponent);

  function Legend(props, context) {
    _classCallCheck(this, Legend);

    var _this = _possibleConstructorReturn(this, (Legend.__proto__ || Object.getPrototypeOf(Legend)).call(this, props, context));

    _this.handleLegendItemClick = function (ev, series) {
      var selectedKeys = _this.state.selectedKeys;


      if (ev.ctrlKey || ev.metaKey) {
        // If the Ctrl button is pressed while selecting
        // the legend item, simply toggle its presence.
        selectedKeys = _this.seriesSelected(series) ? (0, _without3.default)(selectedKeys, series.key) : [series.key].concat(_toConsumableArray(selectedKeys)).sort();
      } else {
        // If Ctrl button is not pressed, select only the clicked item,
        // unless it's the only one selected, in which case remove the selection.
        var onlyThisSelected = _this.seriesSelected(series) && selectedKeys.length === 1;
        selectedKeys = onlyThisSelected ? [] : [series.key];
      }

      _this.setState({ selectedKeys: selectedKeys });
      _this.props.onSelectedKeysChange(selectedKeys);
    };

    _this.handleLegendItemMouseEnter = function (series) {
      _this.setState({ hoveredKey: series.key });
      _this.props.onHoveredKeyChange(series.key);
    };

    _this.handleLegendItemMouseLeave = function () {
      _this.setState({ hoveredKey: null });
      _this.props.onHoveredKeyChange(null);
    };

    _this.handleLegendToggle = function () {
      _this.setState({ shown: !_this.state.shown });
    };

    _this.seriesSelected = function (series) {
      return _this.state.selectedKeys.includes(series.key);
    };

    _this.state = {
      shown: props.shown,
      selectedKeys: props.selectedKeys,
      hoveredKey: null
    };
    return _this;
  }

  _createClass(Legend, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.selectedKeys !== nextProps.selectedKeys) {
        this.setState({ selectedKeys: nextProps.selectedKeys });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var caretIcon = this.state.shown ? 'fa-caret-down' : 'fa-caret-right';

      return _react2.default.createElement(
        LegendContainer,
        { loading: this.props.loading },
        this.props.collapsable && _react2.default.createElement(
          LegendToggle,
          { onClick: this.handleLegendToggle },
          'Legend ',
          _react2.default.createElement(LegendCaret, { className: 'fa ' + caretIcon })
        ),
        this.state.shown && _react2.default.createElement(
          LegendItems,
          null,
          this.props.multiSeries.map(function (series) {
            return _react2.default.createElement(
              LegendItem,
              {
                key: series.key,
                title: series.hoverName,
                onClick: function onClick(ev) {
                  return _this2.handleLegendItemClick(ev, series);
                },
                onMouseEnter: function onMouseEnter() {
                  return _this2.handleLegendItemMouseEnter(series);
                },
                onMouseLeave: function onMouseLeave() {
                  return _this2.handleLegendItemMouseLeave();
                },
                selected: _this2.seriesSelected(series)
              },
              _react2.default.createElement(ColorBox, { color: series.color }),
              _react2.default.createElement(
                LegendItemName,
                null,
                series.legendName
              )
            );
          })
        )
      );
    }
  }]);

  return Legend;
}(_react2.default.PureComponent);

Legend.propTypes = {
  multiSeries: _propTypes2.default.array.isRequired,
  selectedKeys: _propTypes2.default.array.isRequired,
  onSelectedKeysChange: _propTypes2.default.func.isRequired,
  onHoveredKeyChange: _propTypes2.default.func.isRequired,
  loading: _propTypes2.default.bool.isRequired,
  collapsable: _propTypes2.default.bool.isRequired,
  shown: _propTypes2.default.bool.isRequired
};

exports.default = Legend;