'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// NOTE (fbarl): For some reason, doing the animation with
// opacity looks buggy on my Chrome on deep zoom levels.
/* stylelint-disable color-no-hex */
var blinking = (0, _styledComponents.keyframes)(['0%{background-color:transparent;}50%{background-color:#fff;}100%{background-color:transparent;}']);
/* stylelint-enable color-no-hex */

var TimelineLoaderOverlay = _styledComponents2.default.div.attrs({
  style: function style(_ref) {
    var x = _ref.x,
        width = _ref.width;
    return {
      left: x + 'px',
      width: width
    };
  }
}).withConfig({
  displayName: '_TimelineLoader__TimelineLoaderOverlay'
})(['animation:', ' 2s linear infinite;pointer-events:none;position:absolute;opacity:0.65;height:100%;'], blinking);

var TimelineLoader = function TimelineLoader(_ref2) {
  var timeScale = _ref2.timeScale,
      startAt = _ref2.startAt,
      endAt = _ref2.endAt,
      width = _ref2.width;

  var endShift = endAt ? Math.min(timeScale((0, _moment2.default)(endAt)), width) : width;
  var startShift = startAt ? Math.max(timeScale((0, _moment2.default)(startAt)), -width) : -width;
  var length = endShift - startShift;

  return _react2.default.createElement(TimelineLoaderOverlay, { x: startShift, width: length });
};

TimelineLoader.propTypes = {
  timeScale: _propTypes2.default.func.isRequired,
  startAt: _propTypes2.default.string,
  endAt: _propTypes2.default.string,
  width: _propTypes2.default.number.isRequired
};

exports.default = TimelineLoader;